function crossCorr(ac, x, y, dij)         %model 3 and 4 predictions, called by dowjoned.m and fffted.m
    
    today = datetime('09-05-2018','inputformat','MM-dd-yyyy');    %for marking the present day in graphs
    
    pastx = NaT(1,ac);          %divides the input stock and index data into past and future segments so they
                                %can be displayed individually in graphs
    for i=1:ac
        pastx(i) = x(i);
    end
    
    pasty = zeros(1,ac);
    pastdij = zeros(1,ac);
    
    for i=1:ac
        pasty(i) = y(i)/y(ac);        %normalizes the stock data and index data so that they're compatible in
    end                               %the same equations
    for i=1:ac
        pastdij(i) = dij(i)/dij(ac);
    end
    
    superdij = zeros(1,ac+17);
    for i=1:ac+17
        superdij(i) = dij(i)/dij(ac);
    end
    
    futurex = NaT(1,length(x)-ac+1);
 
    for i=1:length(x)-ac+1
        futurex(i) = x(i+ac-1);
    end
    
    futurey = zeros(1,length(y)-ac+1);   
    futuredij = zeros(1,length(dij)-ac+1);
 
    for i=1:length(y)-ac+1
        futurey(i) = y(i+ac-1);
    end
    for i=1:length(dij)-ac+1
        futuredij(i) = dij(i+ac-1)/dij(ac);
    end
    
    fakex = zeros(1,ac);                 %converts the input of dates into real numbers so that they can be
                                         %inputted into calculations
    for i=1:ac
        fakex(i)= datenum(x(i)) - datenum(x(1)) + 1;
    end

    
    p=polyfit(fakex,pasty,1);          %creates a least-squares trendline of the past stock data and 
    pdij=polyfit(fakex,pastdij,1);     %one of the past index data
    
    lst= zeros(1,ac);   
    lstdij= zeros(1,ac);
    
    for i=1:ac
        lst(i)=p(1)*fakex(i)+p(2);
    end
    for i=1:ac
        lstdij(i)=pdij(1)*fakex(i)+pdij(2);
    end
    
    dtd = zeros(1,ac);               %subtraction of the stock data and its trendline to center data along x axis
    dtdij = zeros(1,ac);             %same for the index data
    
    for i = 1:ac
        dtd(i) = pasty(i)-lst(i);
    end
    for i = 1:ac
        dtdij(i) = pastdij(i)-lstdij(i);
    end
    
    if ac < 40                                  %Fourier Series fits based on size of autocrrelation
        f=fit(fakex',dtd','fourier2');
    end
    if ac < 40
        fdij=fit(fakex',dtdij','fourier2');
    end
    
    if ac >= 40 && ac < 60
        f=fit(fakex',dtd','fourier3');
    end
    if ac >= 40 && ac < 60
        fdij=fit(fakex',dtdij','fourier3');
    end    
    
    if ac >= 60
        f=fit(fakex',dtd','fourier4');
    end
    if ac >= 60
        fdij=fit(fakex',dtdij','fourier4');
    end
    
    for i=1:ac+17                                      %Fourier Series fits extended into future
        fakex(i)= datenum(x(i)) - datenum(x(1)) + 1;
    end
    
    for i=1:ac+17
        lst(i)=p(1)*fakex(i)+p(2);
    end
    for i=1:ac+17
        lstdij(i)=pdij(1)*fakex(i)+pdij(2);
    end
    
    model = zeros(1,ac);
    
    for i = 1:ac
        model(i) = f(fakex(i));
    end
    
    yh= zeros(1,ac+17);                    %uses trendlines and Fourier Series fits to create predictions of 
    dijh= zeros(1,ac+17);                  %futures of stock data and index data
    
    for i=1:ac+17
        yh(i)=lst(i)+f(fakex(i));
    end
    for i=1:ac+17
        dijh(i)=lstdij(i)+fdij(fakex(i));
    end    
     
    yhf = zeros(1,length(yh)-ac+1);       %extracts predictions into only their future segments
    dijhf = zeros(1,length(dijh)-ac+1);
    
    for i=1:length(yh)-ac+1
        yhf(i) = yh(i+ac-1);
    end
    for i=1:length(dijh)-ac+1
        dijhf(i) = dijh(i+ac-1);
    end
    
    alpha = corrcoef(dijh,yh);       %performs a cross correlation between the index prediction and
                                     %the stock prediction
    disp(alpha(2));            %prints out the cross correlation coefficient
    

    alphax = abs(alpha(2));

    
    xcorrf = zeros(1,ac+17);          %combines the normalized stock prediction and index prediction into a 
    for i=1:ac+17                     %single prediction, using the cross correlation coefficient to weigh each   
        xcorrf(i) = y(ac)*(alphax*yh(i) + (1-alphax)*dijh(i));   %individual appropriately
    end
    
    xcorrff = zeros(1,length(y)-ac+1);
    
    for i=1:length(y)-ac+1            %extracts prediction into only its future segment
       xcorrff(i) = xcorrf(i+ac-1);
    end
    
    noise = zeros(1,ac);
    
    for i = 1:ac                     %creates a margin of error based on how different past data and 
        noise(i) = xcorrf(i) - y(i); %prediction are
    end
    
    maximum = abs(max(noise));
    
    minimum = abs(min(noise));
    
    error = (maximum+minimum)/2;    %calculates size of error
    
    disp(error*2*100);              %prints out the size of error
    
    upperband = zeros(1,length(xcorrf)-ac+1);
    
    lowerband = zeros(1,length(xcorrf)-ac+1);
    
    for i = 1:ac+17                          %creates error bands bands based on size of error
        upperband(i) = xcorrf(i) + error;
        lowerband(i) = xcorrf(i) - error;
    end
    
    fupperband = zeros(1,length(yh)-ac+1);   %extends error bands into future
    
    flowerband = zeros(1,length(yh)-ac+1);
    
    for i = 1:length(yh)-ac+1
        fupperband(i) = upperband(i+ac-1);
        flowerband(i) = lowerband(i+ac-1);
    end
    
    hold on;                           %creates a graph displaying the relevant stock data, its prediction,
    plot(x,y,'Color',[.6 0 0]);        %and the error bands
    plot(x,xcorrf,'b');
    plot(x,upperband,'Color',[0 0 .6],'Linestyle','--');
    plot(x,lowerband,'Color',[0 0 .6],'Linestyle','--');
    line([today today], [min(lowerband) max(upperband)],'Color','k','LineStyle','--');    
    axis tight;
    xtickformat('MMM-dd');
    title('Cross Correlation Prediction');   
    xlabel('Days');
    ylabel('Closing Price');
    legend({'Closing Price','Price Prediction','Error Bound','Sep 05'},'Location','northwest');
    
    figure;
    
    hold on;                                    %creates a graph displaying the same information as the 
    plot(futurex,futurey,'Color',[.6 0 0]);     %previous graph, but only portraying the future segment of it
    plot(futurex,xcorrff,'b');
    plot(futurex,fupperband,'Color',[0 0 .6],'Linestyle','--');
    plot(futurex,flowerband,'Color',[0 0 .6],'Linestyle','--');  
    axis tight;
    xtickformat('MMM-dd');
    title('Cross Correlation Prediction');   
    xlabel('Days');
    ylabel('Closing Price');
    legend({'Closing Price','Price Prediction','Error Bound'},'Location','northwest');
    
    
end